{% extends 'dataview.html.twig' %}
{% import 'macro/_forms.html.twig' as macros %}

{% block pageTitle 'Utilisateurs' %}

{% block pageActions %}
    <div class="row">
        <div class="col-12 pull-left">
            {{ macros.addButton('user_add', 'Ajouter un utilisateur', 'Ajouter un utilisateur') }}

            {{ macros.addButton(
                'csv_add_users',
                'Ajouter des utilisateurs via csv',
                'Ajouter des utilisateurs via csv',
                'btn-outline-primary'
            ) }}

            {{ macros.batchDeleteButton(
                'user_delete_batch',
                'Supprimer par lot',
                'Supprimer par lot',
                'btn-outline-primary'
            ) }}

            {{ macros.btnInvalidePasswordsWithModal(
                'Invalidation de tous les mots de passe utilisateurs',
                'En invalidant les mots de passe de tous les utilisateurs, cela entraînera la réinitialisation du mot de passe de chacun d\'entre eux.',
                'invalidate_users_password',
            ) }}


            <a href="{{ path('export_csv_users') }}" type="button" class="btn btn-outline-primary">
                <i class="fa fa-download"></i> Exporter les utilisateurs
            </a>

        </div>

        <div class="d-flex justify-content-end">
            {{ macros.searchForm(formSearch, searchTerm, 'user_index') }}
        </div>
    </div>
{% endblock %}

{% block pageTable %}
    <table class="table table-striped mt-3 bg-white">
        <thead>
            <tr class="d-flex">
                <th class="col-3">{{ knp_pagination_sortable(users, 'Nom', 'u.lastName') }}</th>
                <th class="col-3">{{ knp_pagination_sortable(users, 'Nom d\'utilisateur', 'u.username') }}</th>
                <th class="col-2">{{ knp_pagination_sortable(users, 'Profil', 'r.prettyName') }}</th>
                <th class="col-2">{{ knp_pagination_sortable(users, 'Groupe politique', 'p.name') }}</th>
                <th class="active_column d-none">{{ knp_pagination_sortable(users, '', 'u.isActive') }}</th>
                <th class="col-2">Actions</th>
            </tr>
        </thead>
        <tbody>
            {{ macros.emptyList(users, "Aucun utilisateur à afficher") }}

            {% for user in users %}

                <tr class="d-flex">
                    <td class="col-3">
                        <div style="width: 35px;">
                            {% if user.deputy %}
                                <span class="d-inline-block" tabindex="0" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="Suppléant : {{ user.deputy.lastName ~ " " ~ user.deputy.firstName }}">
                                    <span class="text-primary" type="button" disabled><i class="fa fa-user-alt"></i></span>
                                </span>
                            {% endif %}
                        </div>

                        <span>
                            {{ user.lastName}} {{ user.firstName }}
                        </span>
                    </td>
                    <td class="col-3">{{ user.username | noSuffix }}</td>
                    <td class="col-2">{{ user.role ? user.role.prettyName : '' }}</td>
                    <td class="col-2">{{ user.party ?  ( user.party.name|length > 10 ? user.party.name|slice(0,20) ~ '...' : user.party.name)  : ''  }}</td>
                    <td class="active_column d-none">{{ user.isActive }}</td>
                    <td class="col-2 actionButton">

                        {{  macros.btnInvalidateSinglePasswordWithModal(
                            user.id,
                            'Invalidation du mot de passe de l\'utilisateur ' ~ user.lastName ~ ' ' ~ user.firstName,
                            'invalidate_user_password',
                            'En invalidant le mot de passe de l\'utilisateur ' ~ user.lastName ~ ' ' ~ user.firstName ~ ', cela entrainera la réinitialisation de son mot de passe.',
                            users.currentPageNumber,
                        ) }}

                        {{ macros.editButton('user_edit', user.id, 'Modifier l\'utilisateur') }}

                        {{ macros.button_open_modal_secure_delete(
                            user.id,
                            'Suppression de l\'utilisateur ' ~ user.lastName ~ ' ' ~ user.firstName,
                            'user_delete',
                            "La suppression d'un utilisateur entraînera également la suppression de ses données présentes dans les éléments
                            passés auxquels il était lié (anciennes séances, rapports pdf, etc...).

                            Voulez-vous vraiment supprimer l\'utilisateur " ~ user.lastName ~ ' ' ~ user.firstName ~ " ?",
                            users.currentPageNumber,
                            'Supprimer l\'utilisateur',
                        ) }}
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
{% endblock %}

{% block pagePagination knp_pagination_render(users) %}

{% block javascripts %}
    {{ encore_entry_script_tags('passphraseConfirmationBox') }}
    {{ encore_entry_script_tags('enable-popover') }}
{% endblock %}
